# Leviton Cloud Services API model App.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class App(BaseModel):
    def __init__(self, session):
        super(App, self).__init__(session)

    def get(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_organization(self, organizations, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/organizations/{1}".format(self._id, organizations)
        self._session.call_api(api, attribs, 'get')

    def delete_organization(self, organizations, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/organizations/{1}".format(self._id, organizations)
        self._session.call_api(api, attribs, 'delete')

    def put_organization(self, organizations, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/organizations/{1}".format(self._id, organizations)
        self._session.call_api(api, attribs, 'put')

    def get_preference(self, preferences, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/preferences/{1}".format(self._id, preferences)
        self._session.call_api(api, attribs, 'get')

    def delete_preference(self, preferences, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/preferences/{1}".format(self._id, preferences)
        self._session.call_api(api, attribs, 'delete')

    def put_preference(self, preferences, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/preferences/{1}".format(self._id, preferences)
        self._session.call_api(api, attribs, 'put')

    def get_update(self, updates, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/updates/{1}".format(self._id, updates)
        self._session.call_api(api, attribs, 'get')

    def delete_update(self, updates, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/updates/{1}".format(self._id, updates)
        self._session.call_api(api, attribs, 'delete')

    def put_update(self, updates, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/updates/{1}".format(self._id, updates)
        self._session.call_api(api, attribs, 'put')

    def get_subscription_plan(self, subscription_plans, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/subscriptionPlans/{1}".format(self._id, subscription_plans)
        self._session.call_api(api, attribs, 'get')

    def delete_subscription_plan(self, subscription_plans, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/subscriptionPlans/{1}".format(self._id, subscription_plans)
        self._session.call_api(api, attribs, 'delete')

    def put_subscription_plan(self, subscription_plans, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/subscriptionPlans/{1}".format(self._id, subscription_plans)
        self._session.call_api(api, attribs, 'put')

    def get_organizations(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/organizations".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_organizations(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/organizations".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_organizations(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/organizations".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_count(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/organizations/count".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_preferences(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/preferences".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_preferences(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/preferences".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_preferences(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/preferences".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_updates(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/updates".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_updates(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/updates".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_updates(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/updates".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_subscription_plans(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/subscriptionPlans".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_subscription_plans(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/subscriptionPlans".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_subscription_plans(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/subscriptionPlans".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    @staticmethod
    def create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def update(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps"
        session.call_api(api, attribs, 'put')

    @staticmethod
    def post_replace_or_create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/replaceOrCreate"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def post_upsert_with_where(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/upsertWithWhere"
        session.call_api(api, attribs, 'post')

    def get_exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/exists".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_replace(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}/replace".format(self._id)
        self._session.call_api(api, attribs, 'post')

    @staticmethod
    def get(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def get_find_one(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/findOne"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def post_update(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/update"
        session.call_api(api, attribs, 'post')

    def delete(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    @staticmethod
    def get_count(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/count"
        session.call_api(api, attribs, 'get')

    def update(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Apps/{0}".format(self._id)
        self._session.call_api(api, attribs, 'put')

    def get_app(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Preferences/{0}/app".format(self._id)
        self._session.call_api(api, attribs, 'get')

