# Leviton Cloud Services API model IotSwitch.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class IotSwitch(BaseModel):
    def __init__(self, session):
        super(IotSwitch, self).__init__(session)

    def get(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches/{0}".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_residence(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches/{0}/residence".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_residential_room(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches/{0}/residentialRoom".format(self._id)
        self._session.call_api(api, attribs, 'get')

    @staticmethod
    def create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def update(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches"
        session.call_api(api, attribs, 'put')

    @staticmethod
    def post_replace_or_create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches/replaceOrCreate"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def post_upsert_with_where(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches/upsertWithWhere"
        session.call_api(api, attribs, 'post')

    def get_exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches/{0}/exists".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_replace(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches/{0}/replace".format(self._id)
        self._session.call_api(api, attribs, 'post')

    @staticmethod
    def get(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def get_find_one(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches/findOne"
        session.call_api(api, attribs, 'get')

    def delete(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches/{0}".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    @staticmethod
    def get_count(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches/count"
        session.call_api(api, attribs, 'get')

    def update(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches/{0}".format(self._id)
        self._session.call_api(api, attribs, 'put')

    def get_discover(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches/{0}/discover".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_identify(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches/{0}/identify".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def get_iot_switche(self, iot_switches, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/iotSwitches/{1}".format(self._id, iot_switches)
        self._session.call_api(api, attribs, 'get')

    def delete_iot_switche(self, iot_switches, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/iotSwitches/{1}".format(self._id, iot_switches)
        self._session.call_api(api, attribs, 'delete')

    def put_iot_switche(self, iot_switches, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/iotSwitches/{1}".format(self._id, iot_switches)
        self._session.call_api(api, attribs, 'put')

    def get_iot_switches(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/iotSwitches".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_iot_switches(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/iotSwitches".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_iot_switches(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/iotSwitches".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_count(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/iotSwitches/count".format(self._id)
        self._session.call_api(api, attribs, 'get')

