# Leviton Cloud Services API model ResidentialRoom.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class ResidentialRoom(BaseModel):
    def __init__(self, session):
        super(ResidentialRoom, self).__init__(session)

    def get(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_residence(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residence".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_residential_area(self, residential_areas, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialAreas/{1}".format(self._id, residential_areas)
        self._session.call_api(api, attribs, 'get')

    def delete_residential_area(self, residential_areas, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialAreas/{1}".format(self._id, residential_areas)
        self._session.call_api(api, attribs, 'delete')

    def put_residential_area(self, residential_areas, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialAreas/{1}".format(self._id, residential_areas)
        self._session.call_api(api, attribs, 'put')

    def put_rel(self, rel, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialAreas/rel/{1}".format(self._id, rel)
        self._session.call_api(api, attribs, 'put')

    def delete_rel(self, rel, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialAreas/rel/{1}".format(self._id, rel)
        self._session.call_api(api, attribs, 'delete')

    def head_rel(self, rel, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialAreas/rel/{1}".format(self._id, rel)
        self._session.call_api(api, attribs, 'head')

    def get_iot_switche(self, iot_switches, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/iotSwitches/{1}".format(self._id, iot_switches)
        self._session.call_api(api, attribs, 'get')

    def delete_iot_switche(self, iot_switches, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/iotSwitches/{1}".format(self._id, iot_switches)
        self._session.call_api(api, attribs, 'delete')

    def put_iot_switche(self, iot_switches, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/iotSwitches/{1}".format(self._id, iot_switches)
        self._session.call_api(api, attribs, 'put')

    def get_residential_scene(self, residential_scenes, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialScenes/{1}".format(self._id, residential_scenes)
        self._session.call_api(api, attribs, 'get')

    def delete_residential_scene(self, residential_scenes, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialScenes/{1}".format(self._id, residential_scenes)
        self._session.call_api(api, attribs, 'delete')

    def put_residential_scene(self, residential_scenes, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialScenes/{1}".format(self._id, residential_scenes)
        self._session.call_api(api, attribs, 'put')

    def get_residential_areas(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialAreas".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_residential_areas(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialAreas".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_residential_areas(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialAreas".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_count(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialAreas/count".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_iot_switches(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/iotSwitches".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_iot_switches(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/iotSwitches".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_iot_switches(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/iotSwitches".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_residential_scenes(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialScenes".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_residential_scenes(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialScenes".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_residential_scenes(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialScenes".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    @staticmethod
    def create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def update(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms"
        session.call_api(api, attribs, 'put')

    @staticmethod
    def post_replace_or_create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/replaceOrCreate"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def post_upsert_with_where(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/upsertWithWhere"
        session.call_api(api, attribs, 'post')

    def get_exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/exists".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_replace(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/replace".format(self._id)
        self._session.call_api(api, attribs, 'post')

    @staticmethod
    def get(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def get_find_one(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/findOne"
        session.call_api(api, attribs, 'get')

    def delete(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    @staticmethod
    def get_count(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/count"
        session.call_api(api, attribs, 'get')

    def update(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}".format(self._id)
        self._session.call_api(api, attribs, 'put')

    @staticmethod
    def post_turn_on(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/turnOn"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def post_turn_off(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/turnOff"
        session.call_api(api, attribs, 'post')

    def get_residential_room(self, residential_rooms, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/residentialRooms/{1}".format(self._id, residential_rooms)
        self._session.call_api(api, attribs, 'get')

    def delete_residential_room(self, residential_rooms, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/residentialRooms/{1}".format(self._id, residential_rooms)
        self._session.call_api(api, attribs, 'delete')

    def put_residential_room(self, residential_rooms, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/residentialRooms/{1}".format(self._id, residential_rooms)
        self._session.call_api(api, attribs, 'put')

    def get_residential_rooms(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/residentialRooms".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_residential_rooms(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/residentialRooms".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_residential_rooms(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Residences/{0}/residentialRooms".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_residential_room(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/IotSwitches/{0}/residentialRoom".format(self._id)
        self._session.call_api(api, attribs, 'get')

