# Leviton Cloud Services API model ResidentialScene.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class ResidentialScene(BaseModel):
    def __init__(self, session):
        super(ResidentialScene, self).__init__(session)

    def get(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_residential_room(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialRoom".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_residential_action(self, residential_actions, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialActions/{1}".format(self._id, residential_actions)
        self._session.call_api(api, attribs, 'get')

    def delete_residential_action(self, residential_actions, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialActions/{1}".format(self._id, residential_actions)
        self._session.call_api(api, attribs, 'delete')

    def put_residential_action(self, residential_actions, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialActions/{1}".format(self._id, residential_actions)
        self._session.call_api(api, attribs, 'put')

    def get_residential_actions(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialActions".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_residential_actions(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialActions".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_residential_actions(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialActions".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_count(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialActions/count".format(self._id)
        self._session.call_api(api, attribs, 'get')

    @staticmethod
    def create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def update(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes"
        session.call_api(api, attribs, 'put')

    @staticmethod
    def post_replace_or_create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/replaceOrCreate"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def post_upsert_with_where(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/upsertWithWhere"
        session.call_api(api, attribs, 'post')

    def get_exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/exists".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_replace(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/replace".format(self._id)
        self._session.call_api(api, attribs, 'post')

    @staticmethod
    def get(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def get_find_one(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/findOne"
        session.call_api(api, attribs, 'get')

    def delete(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    @staticmethod
    def get_count(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/count"
        session.call_api(api, attribs, 'get')

    def update(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}".format(self._id)
        self._session.call_api(api, attribs, 'put')

    @staticmethod
    def post_execute(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/execute"
        session.call_api(api, attribs, 'post')

    def get_residential_scene(self, residential_scenes, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialScenes/{1}".format(self._id, residential_scenes)
        self._session.call_api(api, attribs, 'get')

    def delete_residential_scene(self, residential_scenes, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialScenes/{1}".format(self._id, residential_scenes)
        self._session.call_api(api, attribs, 'delete')

    def put_residential_scene(self, residential_scenes, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialScenes/{1}".format(self._id, residential_scenes)
        self._session.call_api(api, attribs, 'put')

    def get_residential_scenes(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialScenes".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_residential_scenes(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialScenes".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_residential_scenes(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialRooms/{0}/residentialScenes".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_residential_scene(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialActions/{0}/residentialScene".format(self._id)
        self._session.call_api(api, attribs, 'get')

