# Leviton Cloud Services API model TouchscreenDefinition.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class TouchscreenDefinition(BaseModel):
    def __init__(self, session):
        super(TouchscreenDefinition, self).__init__(session)

    def get(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/TouchscreenDefinitions/{0}".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_whitelist(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/TouchscreenDefinitions/{0}/whitelist".format(self._id)
        self._session.call_api(api, attribs, 'get')

    @staticmethod
    def create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/TouchscreenDefinitions"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def update(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/TouchscreenDefinitions"
        session.call_api(api, attribs, 'put')

    @staticmethod
    def post_replace_or_create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/TouchscreenDefinitions/replaceOrCreate"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def post_upsert_with_where(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/TouchscreenDefinitions/upsertWithWhere"
        session.call_api(api, attribs, 'post')

    def get_exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/TouchscreenDefinitions/{0}/exists".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_replace(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/TouchscreenDefinitions/{0}/replace".format(self._id)
        self._session.call_api(api, attribs, 'post')

    @staticmethod
    def get(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/TouchscreenDefinitions"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def get_find_one(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/TouchscreenDefinitions/findOne"
        session.call_api(api, attribs, 'get')

    def delete(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/TouchscreenDefinitions/{0}".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    @staticmethod
    def get_count(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/TouchscreenDefinitions/count"
        session.call_api(api, attribs, 'get')

    def update(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/TouchscreenDefinitions/{0}".format(self._id)
        self._session.call_api(api, attribs, 'put')

    def get_touchscreen_definition(self, touchscreen_definitions, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Whitelist/{0}/touchscreenDefinitions/{1}".format(self._id, touchscreen_definitions)
        self._session.call_api(api, attribs, 'get')

    def delete_touchscreen_definition(self, touchscreen_definitions, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Whitelist/{0}/touchscreenDefinitions/{1}".format(self._id, touchscreen_definitions)
        self._session.call_api(api, attribs, 'delete')

    def put_touchscreen_definition(self, touchscreen_definitions, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Whitelist/{0}/touchscreenDefinitions/{1}".format(self._id, touchscreen_definitions)
        self._session.call_api(api, attribs, 'put')

    def get_touchscreen_definitions(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Whitelist/{0}/touchscreenDefinitions".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_touchscreen_definitions(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Whitelist/{0}/touchscreenDefinitions".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_touchscreen_definitions(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Whitelist/{0}/touchscreenDefinitions".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_count(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Whitelist/{0}/touchscreenDefinitions/count".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_device_definition(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Touchscreens/{0}/deviceDefinition".format(self._id)
        self._session.call_api(api, attribs, 'get')

