# Leviton Cloud Services API model UserFeedback.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class UserFeedback(BaseModel):
    def __init__(self, session):
        super(UserFeedback, self).__init__(session)

    def get(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks/{0}".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def get_person(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks/{0}/person".format(self._id)
        self._session.call_api(api, attribs, 'get')

    @staticmethod
    def create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def update(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks"
        session.call_api(api, attribs, 'put')

    @staticmethod
    def post_replace_or_create(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks/replaceOrCreate"
        session.call_api(api, attribs, 'post')

    @staticmethod
    def post_upsert_with_where(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks/upsertWithWhere"
        session.call_api(api, attribs, 'post')

    def get_exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks/{0}/exists".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_replace(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks/{0}/replace".format(self._id)
        self._session.call_api(api, attribs, 'post')

    @staticmethod
    def get(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def get_find_one(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks/findOne"
        session.call_api(api, attribs, 'get')

    @staticmethod
    def post_update(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks/update"
        session.call_api(api, attribs, 'post')

    def delete(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks/{0}".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    @staticmethod
    def get_count(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks/count"
        session.call_api(api, attribs, 'get')

    def update(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks/{0}".format(self._id)
        self._session.call_api(api, attribs, 'put')

    @staticmethod
    def post_change_stream(session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/UserFeedbacks/change-stream"
        session.call_api(api, attribs, 'post')

    def get_user_feedback(self, user_feedbacks, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Person/{0}/userFeedbacks/{1}".format(self._id, user_feedbacks)
        self._session.call_api(api, attribs, 'get')

    def delete_user_feedback(self, user_feedbacks, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Person/{0}/userFeedbacks/{1}".format(self._id, user_feedbacks)
        self._session.call_api(api, attribs, 'delete')

    def put_user_feedback(self, user_feedbacks, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Person/{0}/userFeedbacks/{1}".format(self._id, user_feedbacks)
        self._session.call_api(api, attribs, 'put')

    def get_user_feedbacks(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Person/{0}/userFeedbacks".format(self._id)
        self._session.call_api(api, attribs, 'get')

    def post_user_feedbacks(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Person/{0}/userFeedbacks".format(self._id)
        self._session.call_api(api, attribs, 'post')

    def delete_user_feedbacks(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Person/{0}/userFeedbacks".format(self._id)
        self._session.call_api(api, attribs, 'delete')

    def get_count(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Person/{0}/userFeedbacks/count".format(self._id)
        self._session.call_api(api, attribs, 'get')

